//+------------------------------------------------------------------+
//|                                           MA Chanels FiboEnv.mq4 |
//|                                                           njel |
//|                                           iamnotlinked   mod. ik |
//+------------------------------------------------------------------+
#property copyright "njel"
#property link      "iamnotlinked"

#property indicator_chart_window
#property indicator_buffers 7

#property indicator_color1 MediumOrchid
#property indicator_color2 MediumOrchid
#property indicator_color3 MediumOrchid
#property indicator_color4 Violet
#property indicator_color5 MediumOrchid
#property indicator_color6 MediumOrchid
#property indicator_color7 MediumOrchid
//---- input parameters
extern int BarsCount = 1000;
extern int MAPeriod=55;
double  max =0;
double  min =0;
//
/***
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4
MAMethod
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
***/
double    Inc1 = 0.0000;
double    Inc2 = 0.0000;
double    Inc3 = 0.0000;
double    Inc4 = 0.0000;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel(0,"Up100%");

   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexLabel(1,"Dn23.5%");   
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexLabel(2,"Dn38.2,Up61.8");   
   
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexLabel(3,"50%");   
      
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexLabel(4,"Up38.2,Dn61.8");      
   
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexLabel(5,"Up23.5%");      
   
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexLabel(6,"Dn100%");   
 
  IndicatorShortName ("MA Chanels FiboEnv ("+MAPeriod+")");
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   max =0;
   min =0;
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   max =0;
   min =0;
   
   
   if (iBars(NULL,0) < BarsCount)
      BarsCount = iBars(NULL,0) -MAPeriod-1 ;
      
   for (int i =BarsCount; i>=0; i--)
   {
   
      double m = iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_CLOSE,i);
      double top = High[i] - m;      
      if (top > max)
         max = top;
      
      double bottom = Low[i] - m;      
      if (bottom < min)
         min = bottom;
    
   }
   
   if (MathAbs(max) >  MathAbs(min))
      Inc4 = max; 
      else
      Inc4 = min;
    
      Inc1 = (max-min)*0.118; 
      Inc2 = (max-min)*0.264; 
      Inc3 = (max-min)*0.5;
      

   for (i =BarsCount; i>=0; i--)
   {
      ExtMapBuffer1[i] = iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_CLOSE,i) + Inc3; 
      ExtMapBuffer2[i] = iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_CLOSE,i) + Inc2 ;
      ExtMapBuffer3[i] = iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_CLOSE,i) + Inc1 ;
      ExtMapBuffer4[i] = iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_CLOSE,i);      
      ExtMapBuffer5[i] = iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_CLOSE,i) - Inc1;
      ExtMapBuffer6[i] = iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_CLOSE,i) - Inc2;
      ExtMapBuffer7[i] = iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_CLOSE,i) - Inc3;
  
      
   }

   return(0);
  }
//+------------------------------------------------------------------+